﻿
function JigM_CreatePuzzlePieces(x,y)	--x amount, y amount
	JigM_MainMenuFrame:Hide();	-- hide the main menu

	if JigM_DB["XAmount"] then
		for i=1,JigM_DB["XAmount"] do
			for j=1,JigM_DB["YAmount"] do
				if _G["JigM_PuzzlePiece:" .. i .. ":" .. j] then
					_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:Hide()
				end
			end
		end
	end
	
	JigM_DB["XAmount"] = x;
	JigM_DB["YAmount"] = y;
	
	local Width  = JigM_PuzzleFrame:GetWidth()
	local Height = JigM_PuzzleFrame:GetHeight()
	
    JigM_ReferenceImage:SetBackdrop({ 
		bgFile="Interface\\Addons\\JigsawMaster\\Images\\Jigsaws\\" .. JigM_DB["PuzzleID"],
        edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
			left = 4,
			right = 4,
			top = 4,
			bottom = 4
		},
	});
	
	for i=1,x do
		for j=1,y do
			if not _G["JigM_PuzzlePiece:" .. i .. ":" .. j] then
				JigM_PuzzlePiece        = CreateFrame("Frame",           "JigM_PuzzlePiece:"        .. i .. ":" .. j , JigM_PuzzleFrame)
				JigM_PuzzlePieceTexture = JigM_PuzzlePiece:CreateTexture("JigM_PuzzlePieceTexture:" .. i .. ":" .. j )
			end
			
			_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetWidth(Width/JigM_DB["XAmount"]); 
			_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetHeight(Height/JigM_DB["YAmount"]);
			_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetClampedToScreen(true);
			_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetMovable();
			_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetScript("OnMouseDown",function(self)		
				self:StartMoving()
				self:SetToplevel(true)
			end);
			_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetScript("OnMouseUp",function(self)		
				self:StopMovingOrSizing()
				JigM_DropHandler(self);
			end);
			
			_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:Show();
			
			_G["JigM_PuzzlePieceTexture:" .. i .. ":" .. j]:SetAllPoints();
			_G["JigM_PuzzlePieceTexture:" .. i .. ":" .. j]:SetTexture("Interface\\Addons\\JigsawMaster\\Images\\Jigsaws\\" .. JigM_DB["PuzzleID"])
			
			local x1 = (i - 1) * (1 / x)
			local x2 = (i    ) * (1 / x)
			local y1 = (j - 1) * (1 / y) 
			local y2 = (j    ) * (1 / y) 
			
			_G["JigM_PuzzlePieceTexture:" .. i .. ":" .. j]:SetTexCoord(x1, x2, y1, y2);
		end
	end
	
	JigM_PuzzleFrame:Show();
end

function JigM_RandomlyPlacePieces()
	local Width  = JigM_PuzzleFrame:GetWidth()/JigM_DB["XAmount"];
	local Height = JigM_PuzzleFrame:GetHeight()/JigM_DB["YAmount"];
	
	if JigM_DB["XAmount"] < 3 then
		Width = 0;
	end
	
	if JigM_DB["YAmount"] < 3 then
		Height = 0;
	end
	
	JigM_DB["PieceLocations"] = {};	--clear the list of all piece locations
	
	for i=1,JigM_DB["XAmount"] do
		for j=1,JigM_DB["YAmount"] do
			local Section = random(3);
			local XOffset,YOffset;
			
			--Section = 1;
			
			if Section == 1 then
				XOffset = random(0, 200 - Width)
				YOffset = random(0, 700 - Height - 30)
				
				_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetPoint("BottomLeft", JigM_MainFrame, "BottomLeft", XOffset, YOffset);
			elseif Section == 2 then				
				XOffset = random(200, 800 - Width)
				YOffset = random(500, 700 - Height)
				
				_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetPoint("BottomLeft", JigM_MainFrame, "BottomLeft", XOffset, YOffset);
			else
				XOffset = random(800, 1000 - Width)
				YOffset = random(0, 700 - Height - 30)
				
				_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:SetPoint("BottomLeft", JigM_MainFrame, "BottomLeft", XOffset, YOffset);
			end
			--_G["JigM_PuzzlePiece:" .. i .. ":" .. j]:ClearAllPoints();
		end
	end
end

function JigM_RandomlyPlaceSinglePiece(frame)
	local Width  = JigM_PuzzleFrame:GetWidth()/JigM_DB["XAmount"];
	local Height = JigM_PuzzleFrame:GetHeight()/JigM_DB["YAmount"];

	if JigM_DB["XAmount"] < 3 then
		Width = 0;
	end
	
	if JigM_DB["YAmount"] < 3 then
		Height = 0;
	end
	
	local Section = random(3);
	local XOffset,YOffset;
	
	if Section == 1 then
		XOffset = random(0, 200 - Width)
		YOffset = random(0, 700 - Height - 30)
		
		frame:SetPoint("BottomLeft", JigM_MainFrame, "BottomLeft", XOffset, YOffset);
	elseif Section == 2 then				
		XOffset = random(200, 800 - Width)
		YOffset = random(500, 700 - Height)
		
		frame:SetPoint("BottomLeft", JigM_MainFrame, "BottomLeft", XOffset, YOffset);
	else
		XOffset = random(800, 1000 - Width)
		YOffset = random(0, 700 - Height - 30)
		
		frame:SetPoint("BottomLeft", JigM_MainFrame, "BottomLeft", XOffset, YOffset);
	end
end

function JigM_RestoreSaveData()
	JigM_CreatePuzzlePieces( JigM_DB["XAmount"], JigM_DB["YAmount"] )
	
	
	for i=1,JigM_DB["XAmount"] do
		for j=1,JigM_DB["YAmount"] do
			local FrameName = "JigM_PuzzlePiece:" .. i .. ":" .. j;
			
			if JigM_DB["PieceLocations"][FrameName] ~= nil and JigM_DB["PieceLocations"][FrameName] ~= "0:0" then
				local XIndex, YIndex = strsplit(":",JigM_DB["PieceLocations"][FrameName],2);
				XIndex = tonumber(XIndex) - 1;
				YIndex = JigM_DB["YAmount"] - tonumber(YIndex);
				
				local XOffset = (XIndex+0.5) * JigM_PuzzleFrame:GetWidth()  / JigM_DB["XAmount"];
				local YOffset = (YIndex+0.5) * JigM_PuzzleFrame:GetHeight() / JigM_DB["YAmount"];
					
				_G[FrameName]:ClearAllPoints();
				_G[FrameName]:SetPoint("Center", JigM_PuzzleFrame, "BottomLeft", XOffset, YOffset)
			else
				JigM_RandomlyPlaceSinglePiece(_G[FrameName]);
			end			
		end
	end
end


