﻿local StrataList = {
			"BACKGROUND",		--1
			"LOW",				--2
			"MEDIUM",			--3
			"HIGH",				--4 (current)
			"DIALOG",			--5
			"FULLSCREEN",		--6
			"FULLSCREEN_DIALOG",--7
			"TOOLTIP" 			--8
		}

function JigM_SetupOuterFrames()
	JigM_MainFrame = CreateFrame("Frame", "JigM_MainFrame", UIParent)
	JigM_MainFrame:Hide();
	
	local backdrop = {
	  --bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
	  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
	  
	  tile = true,    -- true to repeat the background texture to fill the frame, false to scale it
	  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
	  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
	  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
	    left = 4,
	    right = 4,
	    top = 4,
	    bottom = 4
	  }
	}
	
	
	
	if JigM_DB[JigM_MainFrame:GetName()] then
		JigM_MainFrame:SetPoint(	JigM_DB[JigM_MainFrame:GetName()][1], 
									JigM_DB[JigM_MainFrame:GetName()][2],
									JigM_DB[JigM_MainFrame:GetName()][3],
									JigM_DB[JigM_MainFrame:GetName()][4],
									JigM_DB[JigM_MainFrame:GetName()][5]
									)
	else
		JigM_MainFrame:SetPoint("CENTER");
	end
	JigM_MainFrame:SetScale(JigM_DB["Scale"])
	JigM_MainFrame:SetWidth(1000); 
	JigM_MainFrame:SetHeight(700);
	JigM_MainFrame:SetBackdrop(backdrop)
	JigM_MainFrame:SetMovable();
	JigM_MainFrame:EnableMouse(true);
	JigM_MainFrame:SetClampedToScreen(true);
	JigM_MainFrame:SetFrameStrata(StrataList[4])	
	--JigM_MainFrame:SetBackdropColor(0, 1, 0, 1);
	
	JigM_MainFrameTexture = JigM_MainFrame:CreateTexture("JigM_MainFrameTexture")
	JigM_MainFrameTexture:SetPoint("Top",0,-5)
	JigM_MainFrameTexture:SetPoint("Bottom",0,5)
	JigM_MainFrameTexture:SetPoint("Left",5,0)
	JigM_MainFrameTexture:SetPoint("Right",-5,0)
	JigM_MainFrameTexture:SetTexture(1,1,1,0.4);
	--JigM_PuzzlePieceTexture:SetTexture("")
	
-- backdrop for the title
	local Titlebackdrop = {
           bgFile="Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
           edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
	  
	  tile = false,    -- true to repeat the background texture to fill the frame, false to scale it
	  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
	  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
	  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
	    left = 2,
	    right = 2,
	    top = 2,
	    bottom = 2
	  }
	}
	
-----------------------CLOSE BUTTON
	JigM_Close_Button = CreateFrame("Button", "JigM_Close_Button", JigM_MainFrame, "UIPanelCloseButton")
	JigM_Close_Button:SetWidth(30)
	JigM_Close_Button:SetHeight(30)
	JigM_Close_Button:SetPoint("TOPRIGHT", -5, -5)
	
-- the frame that holds the name
	JigM_TitleFrame=CreateFrame("FRAME","JigM_TitleFrame",JigM_MainFrame);
	JigM_TitleFrame:SetWidth(120)
	JigM_TitleFrame:SetHeight(35)
	JigM_TitleFrame:SetPoint("CENTER",JigM_MainFrame,"Top",0,-5);
	JigM_TitleFrame:SetBackdrop(Titlebackdrop)
	
-- the text in the title box
	JigM_Name_TitleFrame=JigM_TitleFrame:CreateFontString("JigM_Name_TitleFrame","ARTWORK","GameFontNormal");
	JigM_Name_TitleFrame:SetPoint("Center",JigM_TitleFrame,"Center");
	JigM_Name_TitleFrame:SetText("Jigsaw Master")
	
-- make it movable (and save position)
	JigM_TitleFrame:SetScript("OnMouseDown",function(self)
		self = JigM_MainFrame;
		
		self:StartMoving()
	end);
	JigM_TitleFrame:SetScript("OnMouseUp",function(self)
		self = JigM_MainFrame;
	
		self:StopMovingOrSizing()
		
		JigM_DB[self:GetName()] = {};
		JigM_DB[self:GetName()][1], 
		JigM_DB[self:GetName()][2],
		JigM_DB[self:GetName()][3],
		JigM_DB[self:GetName()][4],
		JigM_DB[self:GetName()][5] = self:GetPoint();
		JigM_DB["Scale"] = self:GetScale()
	end);
	
	JigM_CreatePuzzleFrame();
	JigM_CreateMainMenuFrame();
	
	
end


function JigM_CreatePuzzleFrame()
	local backdrop = {
	  bgFile = " ",  -- path to the background texture
	  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
	}

-- The puzzle frame, all puzzle related images go here
	JigM_PuzzleFrame = CreateFrame("Frame", "JigM_PuzzleFrame", JigM_MainFrame)
	JigM_PuzzleFrame:SetWidth(600); 
	JigM_PuzzleFrame:SetHeight(500);
	JigM_PuzzleFrame:SetPoint("Bottom",0,10);
	
	JigM_PuzzleFrameBackdrop = CreateFrame("Frame", "JigM_PuzzleFrameBackdrop", JigM_PuzzleFrame)
	JigM_PuzzleFrameBackdrop:SetWidth(620); 
	JigM_PuzzleFrameBackdrop:SetHeight(520);
	JigM_PuzzleFrameBackdrop:SetBackdrop(backdrop);
	JigM_PuzzleFrameBackdrop:SetPoint("Bottom",0,-10);
	
-- The button to display the reference image (finished image)
	JigM_ReferenceImageButton = CreateFrame("Button", "JigM_ReferenceImageButton:", JigM_PuzzleFrame, "UIPanelButtonTemplate")
	JigM_ReferenceImageButton:SetPoint("TopLeft",JigM_MainFrame,"TopLeft",5,-5);
	JigM_ReferenceImageButton:SetWidth(120)
	JigM_ReferenceImageButton:SetHeight(20)
	
	JigM_ReferenceImageButton:SetText("Show Image")
	JigM_ReferenceImageButton:SetScript("OnClick",	function() 
		if JigM_ReferenceImage:IsShown() then
			JigM_ReferenceImage:Hide();
			JigM_ReferenceImageButton:SetText("Show Image")
		else
			JigM_ReferenceImage:Show();
			JigM_ReferenceImageButton:SetText("Hide Image")
		end
	end)
	
--The reference Image
	JigM_ReferenceImage = CreateFrame("Frame", "JigM_ReferenceImage", JigM_MainFrame)
    JigM_ReferenceImage:SetBackdrop({ 
		bgFile="Interface\\Addons\\JigsawMaster\\Images\\Jigsaws\\" .. JigM_DB["PuzzleID"],
        edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
			left = 4,
			right = 4,
			top = 4,
			bottom = 4
		},
	});
	JigM_ReferenceImage:SetPoint("Top",0,-25);
	JigM_ReferenceImage:SetPoint("Bottom",0,5);
	JigM_ReferenceImage:SetPoint("Left",5,0);
	JigM_ReferenceImage:SetPoint("Right",-5,0);
	JigM_ReferenceImage:SetFrameStrata(StrataList[5]);
	JigM_ReferenceImage:Hide();
	
-- "Puzzle progress is saved between sessions automatically"
	JigM_ProgressIsSaved=JigM_PuzzleFrame:CreateFontString("JigM_ProgressIsSaved","ARTWORK","GameFontNormal");
	JigM_ProgressIsSaved:SetPoint("TopLeft",JigM_MainFrame,"TopLeft", 130, -5);
	JigM_ProgressIsSaved:SetText("Puzzle progress is saved between \nsessions automatically")
	
--return to menu button
	JigM_ReturnToMenuButton = CreateFrame("Button", "JigM_ReturnToMenuButton:", JigM_PuzzleFrame, "UIPanelButtonTemplate")
	JigM_ReturnToMenuButton:SetPoint("TopRight",JigM_MainFrame,"TopRight",-40,-10);
	JigM_ReturnToMenuButton:SetWidth(90)
	JigM_ReturnToMenuButton:SetHeight(20)
	JigM_ReturnToMenuButton:SetText("Main Menu")
	JigM_ReturnToMenuButton:SetScript("OnClick",	function() 
		JigM_PuzzleFrame:Hide();
		JigM_MainMenuFrame:Show();
	end)
	
	JigM_PuzzleFrame:Hide();
end

function JigM_CreateMainMenuFrame()
	JigM_MainMenuFrame = CreateFrame("Frame", "JigM_MainMenuFrame", JigM_MainFrame)
	
-- "Complete puzzles to unlock different images"
	JigM_CompleteMore=JigM_MainMenuFrame:CreateFontString("JigM_CompleteMore","ARTWORK","GameFontNormal");
	JigM_CompleteMore:SetPoint("Top",JigM_MainFrame,"Top", 0, -30);
	JigM_CompleteMore:SetText("Complete puzzles to unlock different images")
	
	local Locations = {
		{100, -50},
		{400, -50},
		{700, -50},
		
		{100, -270},
		{400, -270},
		{700, -270},
		
		{100, -490},
		{400, -490},
		{700, -490},
	}
	
	-- 9 puzzles
	for i=1,9 do
		JigM_SelectionImage = CreateFrame("Frame", "JigM_SelectionImage:" .. i, JigM_MainMenuFrame)
		JigM_SelectionImage:SetWidth(200);
		JigM_SelectionImage:SetHeight(150);
		JigM_SelectionImage:SetPoint("TopLeft", JigM_MainFrame, "TopLeft", Locations[i][1], Locations[i][2])
		JigM_SelectionImage:SetBackdrop({ 
			bgFile="Interface\\Addons\\JigsawMaster\\Images\\Jigsaws\\" .. i,
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			edgeSize = 10,  -- thickness of edge segments and square size of edge corners (in pixels)
			insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
				left = 4,
				right = 4,
				top = 4,
				bottom = 4
			},
		});
		
	-- Easy, Med, Hard and custom buttons
		JigM_SelectionImageEasyButton = CreateFrame("Button", "JigM_SelectionImageEasyButton:" .. i, JigM_MainMenuFrame, "UIPanelButtonTemplate")
		JigM_SelectionImageEasyButton:SetPoint("TopLeft",JigM_SelectionImage,"BottomLeft",0,-5);
		JigM_SelectionImageEasyButton:SetWidth(95)
		JigM_SelectionImageEasyButton:SetHeight(20)
		JigM_SelectionImageEasyButton:SetText("Easy (5x5)")
		JigM_SelectionImageEasyButton:SetScript("OnClick",	function(self) 
			local _, ID = strsplit(":",self:GetName(),2);
			
			JigM_StandardPuzzleSizeHandler(ID, 5, 5);
		end)
		
		JigM_SelectionImageMedButton = CreateFrame("Button", "JigM_SelectionImageMedButton:" .. i, JigM_MainMenuFrame, "UIPanelButtonTemplate")
		JigM_SelectionImageMedButton:SetPoint("TopRight",JigM_SelectionImage,"BottomRight",0,-5);
		JigM_SelectionImageMedButton:SetWidth(95)
		JigM_SelectionImageMedButton:SetHeight(20)
		JigM_SelectionImageMedButton:SetText("Med (10x10)")
		JigM_SelectionImageMedButton:SetScript("OnClick",	function(self) 
			local _, ID = strsplit(":",self:GetName(),2);
			
			JigM_StandardPuzzleSizeHandler(ID, 10, 10);
		end)
		
		JigM_SelectionImageHardButton = CreateFrame("Button", "JigM_SelectionImageHardButton:" .. i, JigM_MainMenuFrame, "UIPanelButtonTemplate")
		JigM_SelectionImageHardButton:SetPoint("TopLeft",JigM_SelectionImage,"BottomLeft",0,-25);
		JigM_SelectionImageHardButton:SetWidth(95)
		JigM_SelectionImageHardButton:SetHeight(20)
		JigM_SelectionImageHardButton:SetText("Hard (15x15)")
		JigM_SelectionImageHardButton:SetScript("OnClick",	function(self) 
			local _, ID = strsplit(":",self:GetName(),2);
			
			JigM_StandardPuzzleSizeHandler(ID, 15, 15);
		end)
		
		JigM_SelectionImageCustomButton = CreateFrame("Button", "JigM_SelectionImageCustomButton:" .. i, JigM_MainMenuFrame, "UIPanelButtonTemplate")
		JigM_SelectionImageCustomButton:SetPoint("TopRight",JigM_SelectionImage,"BottomRight",0,-25);
		JigM_SelectionImageCustomButton:SetWidth(95)
		JigM_SelectionImageCustomButton:SetHeight(20)
		JigM_SelectionImageCustomButton:SetText("Custom")
		JigM_SelectionImageCustomButton:SetScript("OnClick",	function(self) 
			local _, ID = strsplit(":",self:GetName(),2);
			
			JigM_CustomPuzzleSizeHandler(ID);
		end)
	end
	
--continue button
	JigM_ContinueButton = CreateFrame("Button", "JigM_ContinueButton:", JigM_MainMenuFrame, "UIPanelButtonTemplate")
	JigM_ContinueButton:SetPoint("TopRight",JigM_MainFrame,"TopRight",-40,-10);
	JigM_ContinueButton:SetWidth(90)
	JigM_ContinueButton:SetHeight(20)
	JigM_ContinueButton:SetText("Continue")
	JigM_ContinueButton:SetScript("OnClick",	function() 
		if JigM_DB["XAmount"] ~= nil then
			JigM_PuzzleFrame:Show();
			JigM_MainMenuFrame:Hide();
			
			JigM_RestoreSaveData();
		end
	end)
end

function JigM_StandardPuzzleSizeHandler(ID, x, y)
	StaticPopupDialogs["StandardPuzzleSizeHandler"] = {
		text = "Are you sure you want to begin a new puzzle?\n(Progress on current puzzle will be erased)",
		button1 = "Ok",
		button2 = "Cancel",
		OnAccept = function (self)
			JigM_DB["PuzzleID"] = ID;
			JigM_CreatePuzzlePieces(x, y);
			JigM_RandomlyPlacePieces();
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}
	StaticPopup_Show ("StandardPuzzleSizeHandler");
end

function JigM_CustomPuzzleSizeHandler(ID)
	StaticPopupDialogs["CustomPuzzleSizeHandler"] = {
		text = "What size would you like the puzzle to be?\n(To make a 5x5 you would enter 5,5)",
		button1 = "Ok",
		button2 = "Cancel",
		OnShow = function (self, data)
			self.editBox:SetText(JigM_DB["CustomX"] .. "," .. JigM_DB["CustomY"])
		end,
		OnAccept = function (self, data, data2)
			local text = self.editBox:GetText()
			-- do whatever you want with it
			
			if text ~= nil then
				local x, y = strsplit(",",text,2);
				
				if x ~= nil then
					x = tonumber(x);
				end
				
				if y ~= nil then
					y = tonumber(y);
				end
				
				if x ~= nil and y ~= nil then
					JigM_DB["CustomX"] = x;
					JigM_DB["CustomY"] = y;
					
					JigM_DB["PuzzleID"] = ID;
					JigM_CreatePuzzlePieces(x, y);
					JigM_RandomlyPlacePieces();
				end
			end
		end,
		hasEditBox = true,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}
	StaticPopup_Show ("CustomPuzzleSizeHandler");
end
