
function JigM_DropHandler(frame)
	--JigM_DB["XAmount"]
	--JigM_DB["YAmount"]
	
	local x,y = frame:GetCenter()
	
	--x = floor(x);
	--y = floor(y);
	
	local left,right,top,bottom
	
	local left   = JigM_PuzzleFrame:GetLeft()
	local right  = JigM_PuzzleFrame:GetRight()
	local top    = JigM_PuzzleFrame:GetTop()
	local bottom = JigM_PuzzleFrame:GetBottom()
	
	local ID = {0,0}
	
	if x > left then	-- its past the left border
		if x < right then	-- its before the right border
			if y < top then	-- its under the top border
				if y > bottom then	-- its over the bottom border					
					local XIndex = floor(((x-left)/(right-left))   * JigM_DB["XAmount"])
					local YIndex = floor(((y-bottom)/(top-bottom)) * JigM_DB["YAmount"])
					
					local XOffset = (XIndex+0.5) * JigM_PuzzleFrame:GetWidth()  / JigM_DB["XAmount"];
					local YOffset = (YIndex+0.5) * JigM_PuzzleFrame:GetHeight() / JigM_DB["YAmount"];
					
					
					ID = {XIndex+1, JigM_DB["YAmount"] - YIndex}
					
					--print("---")
					--print("xoffset - " .. XOffset);
					--print("yoffset - " .. YOffset);
					
					frame:ClearAllPoints();
					frame:SetPoint("Center", JigM_PuzzleFrame, "BottomLeft", XOffset, YOffset)
				end
			end
		end
	end
	
	JigM_PuzzlePieceUpdate(frame, ID[1], ID[2]);
end

function JigM_PuzzlePieceUpdate(frame, x, y)
	--print(frame:GetName());
	
	JigM_DB["PieceLocations"] = JigM_DB["PieceLocations"] or {};
	JigM_DB["PieceLocations"][frame:GetName()] = x .. ":" .. y;	--JigM_DB["PieceLocations"]["JigM_PuzzlePiece:2:4"] = "2:4"
	
	local TotalPieces = JigM_DB["XAmount"] * JigM_DB["YAmount"];
	local CorrectPieces = 0;
	
	for i=1,JigM_DB["XAmount"] do
		for j=1,JigM_DB["YAmount"] do
			local FrameName = "JigM_PuzzlePiece:" .. i .. ":" .. j;
			if JigM_DB["PieceLocations"][FrameName] ~= nil then
				local _, FrameX,FrameY = strsplit(":",FrameName,3);
				local LocationX,LocationY = strsplit(":",JigM_DB["PieceLocations"][FrameName],2);
				local DroppedFrameName = frame:GetName()
				
				local DroppedFrameNameLocation  = JigM_DB["PieceLocations"][DroppedFrameName]
				local CheckingFrameNameLocation = JigM_DB["PieceLocations"][FrameName]
				
				if CheckingFrameNameLocation ~= "0:0" then
					if DroppedFrameName ~= FrameName then
						if DroppedFrameNameLocation == CheckingFrameNameLocation then
							print("JigsawMaster - Piece moved away")
							JigM_RandomlyPlaceSinglePiece(frame)
							JigM_DB["PieceLocations"][DroppedFrameName] = "0:0";
						end
					end
				
					if FrameX == LocationX then
						if FrameY == LocationY then
							CorrectPieces = CorrectPieces + 1;
						end
					end
				end
			end
		end
	end
	
	if CorrectPieces == TotalPieces then
		JigM_PuzzleCompletedHandler()
	end
end