
function JigM_PuzzleCompletedHandler()
	print("Puzzle Completed");
	
	local Difficulty = {};
	Difficulty[5]  = 1; -- easy
	Difficulty[10] = 2; -- med
	Difficulty[15] = 3; -- hard
	
	local DifficultyIndex = Difficulty[JigM_DB["XAmount"]]
	
	if JigM_DB["XAmount"] ~= JigM_DB["YAmount"] then
		DifficultyIndex = nil;
	end
	
	if DifficultyIndex ~= nil then	--not a custom puzzle		
		local Index = tonumber(JigM_DB["PuzzleID"]);
	
		if not JigM_DB["CompletedPuzzleList"][Index][DifficultyIndex] then
			JigM_DB["CompletedPuzzleList"][Index][DifficultyIndex] = true;
			
			print("New puzzle unlocked");
		end
	end
	
	JigM_ButtonEnablerDisabler();
end

function JigM_ButtonEnablerDisabler()
	local EasyComplete = 0;
	local MedComplete  = 0;
	local HardComplete = 0;
	
	for i=1,9 do
	--	"JigM_SelectionImageEasyButton:"   .. i
	--	"JigM_SelectionImageMedButton:"    .. i
	--	"JigM_SelectionImageHardButton:"   .. i
	--	"JigM_SelectionImageCustomButton:" .. i
		local ShowPicture = false;
		_G["JigM_SelectionImageCustomButton:"   .. i]:Disable()
		
	-- always enable the 1st 2 custom buttons
		if i <= 2 then
			_G["JigM_SelectionImageCustomButton:"   .. i]:Enable()
		end
		
	-- check how many easy, med, hard ones are complete
		if JigM_DB["CompletedPuzzleList"][i][1] then
			EasyComplete = EasyComplete + 1;
			_G["JigM_SelectionImageEasyButton:"   .. i]:SetText("|cff00ff00Easy (5x5)");
		end		

		if JigM_DB["CompletedPuzzleList"][i][2] then
			MedComplete = MedComplete + 1;
			_G["JigM_SelectionImageCustomButton:"   .. i]:Enable();
			_G["JigM_SelectionImageMedButton:"   .. i]:SetText("|cff00ff00Med (10x10)");
		end	
		
		if JigM_DB["CompletedPuzzleList"][i][3] then
			HardComplete = HardComplete + 1;
			_G["JigM_SelectionImageCustomButton:"   .. i]:Enable();
			_G["JigM_SelectionImageHardButton:"   .. i]:SetText("|cff00ff00Hard (15x15)");
		end	
		
		_G["JigM_SelectionImageCustomButton:"   .. i]:SetBackdropColor(0,1,0.5);
		
	--enable the buttons if the previous puzzles were completed
		if i <= EasyComplete + 2 then
			_G["JigM_SelectionImageEasyButton:"     .. i]:Enable()
			ShowPicture = true;
		else
			_G["JigM_SelectionImageEasyButton:"     .. i]:Disable()
		end
		
		if i <= MedComplete + 2 then
			_G["JigM_SelectionImageMedButton:"     .. i]:Enable()
			ShowPicture = true;
		else
			_G["JigM_SelectionImageMedButton:"     .. i]:Disable()
		end
		
		if i <= HardComplete + 2 then
			_G["JigM_SelectionImageHardButton:"     .. i]:Enable()
			ShowPicture = true;
		else
			_G["JigM_SelectionImageHardButton:"     .. i]:Disable()
		end		
		
		if ShowPicture then
			_G["JigM_SelectionImage:" .. i]:SetBackdrop({ 
				bgFile="Interface\\Addons\\JigsawMaster\\Images\\Jigsaws\\" .. i,
				edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
				edgeSize = 10,  -- thickness of edge segments and square size of edge corners (in pixels)
				insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
					left = 4,
					right = 4,
					top = 4,
					bottom = 4
				},
			});
		else
			_G["JigM_SelectionImage:" .. i]:SetBackdrop({ 
				bgFile="Interface\\ICONS\\INV_Misc_QuestionMark",
			});
		end
		
		
	end
end